package br.com.tecpoint.api;
/**
 * This structure is the way in which the application communicates to the Panini Vision API the
    settings of the processing options. Its definition can be found in the header file.
    It must be passed to the API in the DeviceChangeParameters state as parameter of the
    function SetDeviceParameters.
 * @author Cirilo Veloso
 * @version 1.00
 * @see setDeviceParameters
 */
public class DeviceParameters {

    public DeviceParameters() {
        // IMAGE
        // First Front Image Properties
        ImagePropertiesFront1 = new ImageProperties();
        // Second Front Image Properties
        ImagePropertiesFront2 = new ImageProperties();
        // First Rear Image Properties
        ImagePropertiesRear1 = new ImageProperties();
        // Second Rear Image Properties
        ImagePropertiesRear2 = new ImageProperties();

        // SNIPPETS
        SnippetProperties0 = new SnippetProperties();
        SnippetProperties1 = new SnippetProperties();
        SnippetProperties2 = new SnippetProperties();
        SnippetProperties3 = new SnippetProperties();
        SnippetProperties4 = new SnippetProperties();
        SnippetProperties5 = new SnippetProperties();
        SnippetProperties6 = new SnippetProperties();
        SnippetProperties7 = new SnippetProperties();
        SnippetProperties8 = new SnippetProperties();
        SnippetProperties9 = new SnippetProperties();

    }
    // MICR
    // MICR Enabling
    public int bMICREnable;
    // MICR Font(0=CMC7  1=E13B  2=AUTO, Default: E13B)
    public int nMICRFont;
    // MICR Waveform File Saving Enabling
    public int bMICRSaveSamples;
    // Spaces management (0=NONE  1=SINGLE  2=ALL, Default: NONE)
    public int nMICRSpaces;
    // Micr+ Library Parameters
    // Reject Symbol Character (Default: '?')
    public char cRejectSymbol;
    // Reserved, MUST BE 0
    public int nReserved;
    // Reserved, MUST BE FALSE
    public int bReserved;
    // IMAGE
    // First Front Image Properties
    public ImageProperties ImagePropertiesFront1;
    // Second Front Image Properties
    public ImageProperties ImagePropertiesFront2;
    // First Rear Image Properties
    public ImageProperties ImagePropertiesRear1;
    // Second Rear Image Properties
    public ImageProperties ImagePropertiesRear2;
    // SNIPPETS
    public SnippetProperties SnippetProperties0;
    public SnippetProperties SnippetProperties1;
    public SnippetProperties SnippetProperties2;
    public SnippetProperties SnippetProperties3;
    public SnippetProperties SnippetProperties4;
    public SnippetProperties SnippetProperties5;
    public SnippetProperties SnippetProperties6;
    public SnippetProperties SnippetProperties7;
    public SnippetProperties SnippetProperties8;
    public SnippetProperties SnippetProperties9;
    // PRINTER
    // Ink-Jet Enabling
    public int bPrintEnable;
    // WORKING MODE
    // One Document feeding option
    public int bOneDoc;
    // Feeding options (HOPPER FEED = 0, DROP FEED = 1)
    public int nFeedingMode;
//	 // MICR
//    // MICR Enabling
//    
//    public boolean bMICREnable;
//    // MICR Font(0=CMC7  1=E13B  2=AUTO, Default: E13B)
//    
//    public short nMICRFont;
//    // MICR Waveform File Saving Enabling
//   
//    public boolean bMICRSaveSamples;
//    // Spaces management (0=NONE  1=SINGLE  2=ALL, Default: NONE)
//    
//    public short nMICRSpaces;
//
//    // Micr+ Library Parameters
//    // Reject Symbol Character (Default: '?')
//    
//    public byte cRejectSymbol;
//    // Reserved, MUST BE 0
//    
//    public short nReserved;
//    // Reserved, MUST BE FALSE
//
//    public boolean bReserved;
//
//    // IMAGE
//    // First Front Image Properties
//    public IMAGE_PROPERTIES ImagePropertiesFront1;
//    // Second Front Image Properties
//    public IMAGE_PROPERTIES ImagePropertiesFront2;
//    // First Rear Image Properties
//    public IMAGE_PROPERTIES ImagePropertiesRear1;
//    // Second Rear Image Properties
//    public IMAGE_PROPERTIES ImagePropertiesRear2;
//    
//    // SNIPPETS
//    public SNIPPET_PROPERTIES SnippetProperties0;
//    public SNIPPET_PROPERTIES SnippetProperties1;
//    public SNIPPET_PROPERTIES SnippetProperties2;
//    public SNIPPET_PROPERTIES SnippetProperties3;
//    public SNIPPET_PROPERTIES SnippetProperties4;
//    public SNIPPET_PROPERTIES SnippetProperties5;
//    public SNIPPET_PROPERTIES SnippetProperties6;
//    public SNIPPET_PROPERTIES SnippetProperties7;
//    public SNIPPET_PROPERTIES SnippetProperties8;
//    public SNIPPET_PROPERTIES SnippetProperties9;
//
//    // PRINTER
//    // Ink-Jet Enabling
//    public boolean bPrintEnable;
//    // WORKING MODE
//    // One Document feeding option          
//    public boolean bOneDoc;
//    // Feeding options (HOPPER FEED = 0, DROP FEED = 1)
//    public short nFeedingMode;
}
