package br.com.tecpoint.api.impl;


import br.com.tecpoint.api.*;
import br.com.tecpoint.api.win32.W32API.HWND;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import java.awt.Component;
import java.util.HashMap;

/**
 * General Functions to help
 * @version 1.00
 * @author Cirilo Veloso
 */
public class Utils {

   public  static HashMap<String, String> methods = new HashMap<String, String>();

    static {
        methods.put("ChangeParameters", "?ChangeParameters@@YGHK@Z");
        methods.put("DisableDownStreamImage", "?DisableDownStreamImage@@YGHKK@Z");
        methods.put("EnableFranking", "?EnableFranking@@YGHKKK@Z");
        methods.put("FreeImagesBuffer", "?FreeImagesBuffer@@YGHPAU_ImagesStruct@@@Z");
        methods.put("FreeSnippetBuffer", "?FreeSnippetBuffer@@YGHPAU_ImagesStruct@@@Z");
        methods.put("FreeTrack", "?FreeTrack@@YGHKE@Z");
        methods.put("GetApiError", "?GetApiError@@YGHPAK@Z");
        methods.put("GetApiErrorString", "?GetApiErrorString@@YGHPADH@Z");
        methods.put("GetApiRelease", "?GetApiRelease@@YGHPADE@Z");
        methods.put("GetAvailablePockets", "?GetAvailablePockets@@YGHKPAE@Z");
        methods.put("GetDeviceError", "?GetDeviceError@@YGHKPAK@Z");
        methods.put("GetDeviceErrorString", "?GetDeviceErrorString@@YGHKPADH@Z");
        methods.put("GetDeviceFeature", "?GetDeviceFeature@@YGHKKPAXK@Z");
        methods.put("GetDeviceParameters", "?GetDeviceParameters@@YGHKPAU_DeviceParameters@@@Z");
        methods.put("GetDeviceState", "?GetDeviceState@@YGHKPAK@Z");
        methods.put("GetDeviceStateString", "?GetDeviceStateString@@YGHKPADH@Z");
        methods.put("GetDocumentLength", "?GetDocumentLength@@YGHKKPAK@Z");
        methods.put("GetDocumentType", "?GetDocumentType@@YGHKKPAK@Z");
        methods.put("GetDoubleFeedingResult", "?GetDoubleFeedingResult@@YGHKKPAH@Z");
        methods.put("GetDriverRelease", "?GetDriverRelease@@YGHPADE@Z");
        methods.put("GetFullPocketStatus", "?GetFullPocketStatus@@YGHKPAKH@Z");
        methods.put("GetFwVersion", "?GetFwVersion@@YGHKPADE@Z");
        methods.put("GetHistoricalCounter", "?GetHistoricalCounter@@YGHKKPAK@Z");
        methods.put("GetIDCardDescription", "?GetIDCardDescription@@YGHKPAPADPAHPAU_tagDevices@@@Z");
        methods.put("GetIQAResults", "?GetIQAResults@@YGHKKIKPAH@Z");
        methods.put("GetMagCardResult", "?GetMagCardResult@@YGHKPADK@Z");
        methods.put("GetMaxDPM", "?GetMaxDPM@@YGHKPAH@Z");
        methods.put("GetMicrCodeline", "?GetMicrCodeline@@YGHKPADK@Z");
        methods.put("GetOCRCodeline", "?GetOCRCodeline@@YGHKPAEPADKHH@Z");
        methods.put("GetPrinterCartridgeInfo", "?GetPrinterCartridgeInfo@@YGHKPAHPAK@Z");
        methods.put("GetSerialNumber", "?GetSerialNumber@@YGHKPADE@Z");
        methods.put("GetSorterError", "?GetSorterError@@YGHKPAK@Z");
        methods.put("GetSorterErrorString", "?GetSorterErrorString@@YGHKPADH@Z");
        methods.put("GetSorterParameter", "?GetSorterParameter@@YGHKGPAU_AParameter@@@Z");
        methods.put("GetUsbError", "?GetUsbError@@YGHKPAK@Z");
        methods.put("GetUsbErrorString", "?GetUsbErrorString@@YGHKPADH@Z");
        methods.put("GetVirtualEndorsementAreaProperty", "?GetVirtualEndorsementAreaProperty@@YGHKKKPAX@Z");
        methods.put("IsFeederEmpty", "?IsFeederEmpty@@YGHKPAH@Z");
        methods.put("IsTrackFree", "?IsTrackFree@@YGHKPAH@Z");
        methods.put("OnLine", "?OnLine@@YGHK@Z");
        methods.put("ReadCryptedIDCard", "?ReadCryptedIDCard@@YGHKPAE0@Z");
        methods.put("ReadPrinterDropsCounter", "?ReadPrinterDropsCounter@@YGHKPAK@Z");
        methods.put("ResetHistoricalCounter", "?ResetHistoricalCounter@@YGHKK@Z");
        methods.put("ResetPrinterDropsCounter", "?ResetPrinterDropsCounter@@YGHK@Z");
        methods.put("Rs232GetLen", "?Rs232GetLen@@YGHKPAE@Z");
        methods.put("Rs232Read", "?Rs232Read@@YGHKPAEE@Z");
        methods.put("Rs232SetBaud", "?Rs232SetBaud@@YGHKI@Z");
        methods.put("Rs232Write", "?Rs232Write@@YGHKPAEE@Z");
        methods.put("SendPrinterData", "?SendPrinterData@@YGHKKUtagLOGFONTA@@PADK1KK@Z");
        methods.put("SetAGPLines", "?SetAGPLines@@YGHKE@Z");
        methods.put("SetDeviceParameters","?SetDeviceParameters@@YGHKU_DeviceParameters@@@Z");
        methods.put("SetFeederLimit", "?SetFeederLimit@@YGHKE@Z");
        methods.put("SetFeedingMode", "?SetFeedingMode@@YGHKE@Z");
        methods.put("SetHandDropDly", "?SetHandDropDly@@YGHKK@Z");
        methods.put("SetIQAParameter", "?SetIQAParameter@@YGHKIKKH@Z");
        methods.put("SetImageAdjustment", "?SetImageAdjustment@@YGHKHHH@Z");
        methods.put("SetMaxDPM", "?SetMaxDPM@@YGHKH@Z");
        methods.put("SetMaxPocket", "?SetMaxPocket@@YGHKE@Z");
        methods.put("SetPocket", "?SetPocket@@YGHKKE@Z");
        methods.put("SetSorterParameter", "?SetSorterParameter@@YGHKGG@Z");
        methods.put("SetVirtualEndorsement", "?SetVirtualEndorsement@@YGHKKPAD0K@Z");
        methods.put("SetVirtualEndorsementAreaProperty", "?SetVirtualEndorsementAreaProperty@@YGHKKKPAX@Z");
        methods.put("ShutDown", "?ShutDown@@YGHK@Z");
        methods.put("StartFeeding", "?StartFeeding@@YGHK@Z");
        methods.put("StartUp", "?StartUp@@YGKPAUHWND__@@I@Z");
        methods.put("StopFeeding", "?StopFeeding@@YGHK@Z");
        methods.put("UpgradeIDCard", "?UpgradeIDCard@@YGHKPAEK@Z");
        methods.put("VApiGetError", "?VApiGetError@@YGKXZ");
        methods.put("VApiGetErrorString", "?VApiGetErrorString@@YGKKPADH@Z");
        methods.put("VApiGetVersion", "?VApiGetVersion@@YGKPADK@Z");
        methods.put("VApiSetDeviceEngine", "?VApiSetDeviceEngine@@YGKK@Z");
        methods.put("SetDeviceParametersHelpDefault", "?SetParamsHelpDefault@@YGHK@Z");
        methods.put("SetDeviceParametersHelp2","?SetParamsHelp2@@YGHKHHIIIIHHHDIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII@Z");
        methods.put("SendPrinterDataHelp","?SendPrintDataHelp@@YGHKKPAUtagLOGFONTA@@PADK1KK@Z");
        methods.put("GetIDCardDescHelp","?GetIDCardDescHelp@@YGHKPADJPAU_tagDevices@@@Z");
    }

    Utils() {
        super();
        // TODO Auto-generated constructor stub
    }

    public static HashMap<String, String> getMethods() {
        return methods;
    }

    public static void setMethods(HashMap<String, String> methods) {
        Utils.methods = methods;
    }

    //Simple little function that converts a byte into hex
    public static String ConvertToHex(byte value, int padZeros) {
        int i = value & 0xFF;
        String str = Integer.toHexString(i);
        str = str.toUpperCase();
        int pad = padZeros - str.length();
        if (pad < 0) {
            return str;
        }
        for (int x = 0; x < pad; ++x) {
            str = "0" + str;
        }
        return str;
    }

    public static String ConvertToHex(int value, int padZeros) {
        String str = Integer.toHexString(value);
        str = str.toUpperCase();
        int pad = padZeros - str.length();
        if (pad < 0) {
            return str;
        }
        for (int x = 0; x < pad; ++x) {
            str = "0" + str;
        }
        return str;
    }

    public static String byteToString(byte b[]) {
        int len = 0;
        while (b[len] != 0) {
            ++len;
        }
        return new String(b, 0, len);
    }

    public static String deviceTypeString(int type) {
        String result = "unknown";
        switch (type) {
            case VAPIInterface.DEVICE_MYVISIONX: {
                result = "MyVisionX";
                break;
            }
            case VAPIInterface.DEVICE_VISIONX: {
                result = "Vision X";
                break;
            }
            case VAPIInterface.DEVICE_VISIONS: {
                result = "Vision S";
                break;
            }
            case VAPIInterface.DEVICE_IDEAL: {
                result = "I:Deal";
                break;
            }

        }
        return result;
    }

    public static boolean intToBool(int num) {
        return ((num == 1) ? true : false);
    }
    public static int boolTInt(boolean valor) {
        return ((valor==true) ? 1 : 0);
    }

     public static int hwndToInt(HWND hwnd) {
        String hex = hwnd.toString();
        int pos = hex.indexOf('@');
        hex = hex.substring(pos + 1, hex.length());
        return Integer.parseInt(hex, 16);
    }

     public static HWND getHWnd(Component w) {
        HWND h = new HWND();
        h.setPointer(Native.getComponentPointer(w));
        return h;
    }

     public static String getDocumentTypeString(int type){
        String types[] = {"Cheque","Card"};
        return types[type];
    }

    public static String getJaiFileFormatName(int format){
        String[] fileFormatName = {"BMP","FPX","GIF","JPEG","PNG","PNM","TIFF"};
        String result = "JPEG";
        switch (format) {
            case VAPIInterface.FORMAT_GIV:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_JPEG:
                result = fileFormatName[3];
                break;
            case VAPIInterface.FORMAT_BMP:
                result = fileFormatName[0];
                break;
            case VAPIInterface.FORMAT_NATIVE_BMP:
                result = fileFormatName[0];
                break;
            case VAPIInterface.FORMAT_BMP_COLOR:
                result = fileFormatName[0];
                break;
            case VAPIInterface.FORMAT_JPEG_COLOR:
                result = fileFormatName[3];
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_RED:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_GREEN:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_BLUE:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_BMP_TRUE_COLOR:
                result = fileFormatName[0];
                break;
            case VAPIInterface.FORMAT_JPEG_TRUE_COLOR:
                result = fileFormatName[3];
                break;
            case VAPIInterface.FORMAT_GIV_DOR_TRUE_COLOR:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_GIV_DOG_TRUE_COLOR:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_GIV_DOB_TRUE_COLOR:
                result = fileFormatName[6];
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_IR:
                result = fileFormatName[6];
                break;
        }
        return result;
    }

    public static String getExtension(int format){
        String extension = "jpg";
        switch (format) {
            case VAPIInterface.FORMAT_GIV:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_JPEG:
                extension = ".jpg";
                break;
            case VAPIInterface.FORMAT_BMP:
                extension = ".bmp";
                break;
            case VAPIInterface.FORMAT_NATIVE_BMP:
                extension = ".bmp";
                break;
            case VAPIInterface.FORMAT_BMP_COLOR:
                extension = ".bmp";
                break;
            case VAPIInterface.FORMAT_JPEG_COLOR:
                extension = ".jpeg";
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_RED:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_GREEN:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_BLUE:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_BMP_TRUE_COLOR:
                extension = ".bmp";
                break;
            case VAPIInterface.FORMAT_JPEG_TRUE_COLOR:
                extension = ".jpg";
                break;
            case VAPIInterface.FORMAT_GIV_DOR_TRUE_COLOR:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_GIV_DOG_TRUE_COLOR:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_GIV_DOB_TRUE_COLOR:
                extension = ".tif";
                break;
            case VAPIInterface.FORMAT_GIV_DROP_OUT_IR:
                extension = ".tif";
                break;
        }
        return extension;
    }

    public static int getArrayIndex(int[] array, int value){
        int found = 0;
        for(int i = 0; i < array.length; i++){
            if(array[i]==value){
                found = i;
                break;
            }
        }
        return found;
    }

    public static byte[] getImageByteFormLparamIntValue(int lparamInt, int imageNum, ImagesStruct.ByRef is) {
        //ImagesStruct.ByRef is=new ImagesStruct.ByRef();
        byte[] structBytes = new byte[is.size()];
        Pointer pointerToResult = new IntByReference(lparamInt).getPointer().getPointer(0);
        pointerToResult.read(0, structBytes, 0, structBytes.length);
        Pointer structMemory = is.getPointer();
        structMemory.write(0, structBytes, 0, structBytes.length);
        is.read();
        CompressedImage.ByRef ci = new CompressedImage.ByRef();
        byte[] cistructBytes = new byte[ci.size()];
        Pointer cipointerToResult = is.Image.getPointer();
        cipointerToResult.read(ci.size() * (imageNum - 1), cistructBytes, 0, cistructBytes.length);
        Pointer ciStructMemory = ci.getPointer();
        ciStructMemory.write(0, cistructBytes, 0, cistructBytes.length);
        ci.read();
        byte[] imageBytes = new byte[ci.bufferLen];
        ci.pBuffer.read(0, imageBytes, 0, ci.bufferLen);
        return imageBytes;
    }

}
